Bug 309761 - utrace: ptrace operations create unkillable process eating 100% cpu
utrace: ptrace operations create unkillable process eating 100% cpu
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.1
i686 Linux
medium Severity medium
: beta
: ---
Assigned To: Roland McGrath
Martin Jenner
: Regression
Depends On: 267161
Blocks: 425461
  Show dependency treegraph
 
Reported: 2007-09-27 15:33 EDT by Jan Kratochvil
Modified: 2010-10-22 15:02 EDT (History)
1 user (show)

See Also:
Fixed In Version: RHBA-2008-0314
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-05-21 10:56:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Testcase. (11.07 KB, text/plain)
2007-09-27 15:33 EDT, Jan Kratochvil
no flags Details

  None (edit)
Description Jan Kratochvil 2007-09-27 15:33:52 EDT
+++ This bug was initially created as a clone of Bug #267161 +++

Description of problem:
I have a test program (step-hang) which I will attach. It does a
PTRACE_SINGLESTEP to step into a signal handler, then kills the
debugged child. Once every 100 or so times it does this, the debugger
(not the child) becomes hung in a 100% cpu state and cannot be killed
or even SIGSTOPed to make it stop eating the CPU.

Version-Release number of selected component (if applicable):
kernel-2.6.18-48.el5.x86_64

How reproducible:
Reproduced on the main loop run (approx.) # 580000.
Currently te testcase runs 1000000 cycles (~5 minutes).

Steps to Reproduce:
1. gcc -o tracer-lockup-on-sighandler-kill tracer-lockup-on-sighandler-kill.c
-Wall -ggdb2
2. ./tracer-lockup-on-sighandler-kill
3. echo $?
  
Actual results:
We have a weiner!
The test_signalstep child pid 24289 is apparently hung.
The bug has been reproduced!
Accumulated output from test:
INFO: test_signalstep pid 24290 status: stopped with signum 10
INFO: test_signalstep pid 24290 status: stopped with signum 5
INFO: test_signalstep pid 24290 status: stopped with signum 5
INFO: test_signalstep pid 24290 status: stopped with signum 5
INFO: test_signalstep pid 24290 status: stopped with signum 5
INFO: test_signalstep pid 24290 PC = 0x400bc8
DEF: STEP_INTO_HANDLER=1
INFO: calling kill_kid_dead(24290)
INFO: returned from kill_kid_dead(24290)
1

Expected results:
0
Comment 1 Jan Kratochvil 2007-09-27 15:33:52 EDT
Created attachment 208941 [details]
Testcase.
Comment 2 Mike Gahagan 2007-10-25 13:08:38 EDT
I've been able to reproduce this bug on both the -53 and -54 kernels. It
reproduces nicely in RHTS.
Comment 3 Eric Bachalo 2007-12-14 15:39:19 EST
Roland is/will be working on this issue.
Comment 4 RHEL Product and Program Management 2007-12-14 15:45:50 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 6 Don Zickus 2007-12-21 15:18:06 EST
in 2.6.18-62.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 8 Mike Gahagan 2008-01-28 14:40:19 EST
Confirmed test is passing on x86_64 with the -75 kernel. There are also passing
results in RHTS on other arch's with slightly older kernels.
Comment 10 errata-xmlrpc 2008-05-21 10:56:39 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2008-0314.html

Note You need to log in before you can comment on or make changes to this bug.